/* this file is not the original. changes are signed with 'TMoor'. TMoor */



/* 
 * Generic mode timing module.
 */

#include "timing.h"	/* Types. */

#include "libvga.h"	/* for __svgalib_infotable (remove me) */
#include "driver.h"	/* for __svgalib_monitortype (remove me) */


/* #define DEBUG */ /* print messages while searching for suitible timings*/

/* Standard mode timings. i did not touch this table ! TMoor */

MonitorModeTiming standard_timings[] = {
/* 320x200 @ 70 Hz, 31.5 kHz hsync */
{ 12588, 320, 336, 384, 400, 400, 409, 411, 450, DOUBLESCAN, NULL },
/* 320x240 @ 60 Hz, 31.5 kHz hsync */
{ 12588, 320, 336, 384, 400, 480, 491, 493, 525, DOUBLESCAN, NULL  },
/* 320x240 @ 72 Hz, 36.5 kHz hsync */
{ 15750, 320, 336, 384, 400, 480, 488, 491, 521, DOUBLESCAN, NULL  },
/* 640x400 at 70 Hz, 31.5 kHz hsync */
{ 25175, 640, 664, 760, 800, 400, 409, 411, 450, 0, NULL  },
/* 640x480 at 60 Hz, 31.5 kHz hsync */
{ 25175, 640, 664, 760, 800, 480, 491, 493, 525, 0, NULL  },
/* 640x480 at 72 Hz, 36.5 kHz hsync */
{ 31500, 640, 664, 760, 800, 480, 491, 493, 521, 0, NULL  },
/* 800x600 at 56 Hz, 35.15 kHz hsync */
{ 36000, 800, 824, 896, 1024, 600, 601, 603, 625, 0, NULL  },
/* 800x600 at 60 Hz, 37.8 kHz hsync */
{ 40000, 800, 840, 968, 1056, 600, 601, 605, 628, PHSYNC | PVSYNC, NULL  },
/* 1024x768 at 87 Hz interlaced, 35.5 kHz hsync */
{ 44900, 1024, 1048, 1208, 1264, 768, 776, 784, 817, INTERLACED , NULL },
/* 800x600 at 72 Hz, 48.0 kHz hsync */
{ 50000, 800, 856, 976, 1040, 600, 637, 643, 666, PHSYNC | PVSYNC , NULL },
/* 1024x768 at 60 Hz, 48.4 kHz hsync */
{ 65000, 1024, 1032, 1176, 1344, 768, 771, 777, 806, NHSYNC | NVSYNC, NULL  },
/* 1024x768 at 70 Hz, 56.6 kHz hsync */
{ 75000, 1024, 1048, 1184, 1328, 768, 771, 777, 806, NHSYNC | NVSYNC, NULL  },
/* 1280x1024 at 87 Hz interlaced, 51 kHz hsync */
{ 80000, 1280, 1296, 1512, 1568, 1024, 1025, 1037, 1165, INTERLACED , NULL },
/* 1024x768 at 76 Hz, 62.5 kHz hsync */
{ 85000, 1024, 1032, 1152, 1360, 768, 784, 787, 823, 0 , NULL }, 
/* 1280x1024 at 60 Hz, ? kHz hsync */
{ 110000, 1280, 1328, 1512, 1712, 1024, 1025, 1028, 1054, 0 , NULL },
/* 1280x1024 at 70 Hz, ? kHz hsync */
{ 135000, 1280, 1312, 1456, 1712, 1024, 1027, 1030, 1064, 0 , NULL }
};

#define NUMBER_OF_STANDARD_MODES \
	(sizeof(standard_timings) / sizeof(standard_timings[0]))

static MonitorModeTiming* user_timings= NULL;	

void definetiming(MonitorModeTiming* moti) {
   MonitorModeTiming *newmoti;
   MonitorModeTiming *actmoti;
   int i;

   newmoti= malloc(sizeof(MonitorModeTiming));
   *newmoti=*moti;
   newmoti->nextinthelist=NULL;
   if(!user_timings) {
     user_timings=newmoti; 
   } else {
     for(actmoti=user_timings;actmoti->nextinthelist != NULL; 
          actmoti=actmoti->nextinthelist);
     actmoti->nextinthelist=newmoti;
   }
#ifdef DEBUG
    i=1;
    for(actmoti=user_timings;actmoti->nextinthelist != NULL;
        actmoti=actmoti->nextinthelist) i++;
    printf("definetiming %d: %3.2f %d %d %d %d %d %d %d %d \n",
       i,newmoti->pixelClock / 1000.0,
       newmoti->HDisplay,newmoti->HSyncStart,newmoti->HSyncEnd,newmoti->HTotal,    
       newmoti->VDisplay,newmoti->VSyncStart,newmoti->VSyncEnd,newmoti->VTotal);    
#endif
} 

/*
 * this is not really a monitor checking. but its at least something. TMoor 
 *
 * by the way: i dont think, that the fixed table, which did the checking
 * before my hacking, did its job right:
 * mode line number 3 is a 36.5 khz (says the comment above the line)
 * and it is alowed to be used with any monitor (said the cheking-table).
 * is this because of "doublescan" ?
 * by the way by the way: all the horizontal frequencies in the comments
 * seem to be calculated by dividing the clock by the total number of
 * pixels in each scanline. i do understans this. but mode number 3
 * would than be a 39.3 khz mode. am i wrong ?
 *
 * of cause, it could be that this was done by someone, who
 * knows more about those things, than i do. in this case, dear someone,
 * remove these lines. */

int timing_within_monitor_spec(MonitorModeTiming* MMT) {
   float hfreq;

#ifdef 0 
   printf("within_monitor_spec ? (no) ");   
#endif
   hfreq=MMT->pixelClock/MMT->HTotal;  /* this is the hsync freq in KHz, isnt it? TMoor */
   switch(__svgalib_monitortype) {
     case 0: if(.99*hfreq > 31.5) return(0);
     case 1: if(.99*hfreq > 35.2) return(0);
     case 2: if(.99*hfreq > 35.5) return(0);
     case 3: if(.99*hfreq > 38) return(0);
     case 4: if(.99*hfreq > 48.3) return(0);
     case 5: if(.99*hfreq > 56) return(0);
     /* case 6: if(.99*hfreq > 60) return(0); use this for no limits */
   }
#ifdef 0
   printf("yes ! ");   
#endif
   return(1);
}   

/* this is, how it was before:                TMoor */ 

/*
 * The getmodetiming function looks up a mode in the standard mode
 * timings, choosing the mode with the highest dot clock that matches
 * the requested svgalib mode, and is supported by the hardware
 * (card limits, and monitor type). cardlimits points to a structure
 * of type CardSpecs that describes the dot clocks the card supports
 * at different depths. Returns non-zero if no mode is found.
 */

/* it is now quite the same, ... 

   ... but before the standard timings are asked,
   the user defined timings from the configfile are asked.  
   if a suitable timing is found there, the standard timings are not asked,
   even if there could be found a better timing. so only if the user
   did not define a modeline in the required resolution, a standard timing
   might be used. that is to allow the user to overwrite standard timings. 
   TMoor */

/*
 * findclock is an auxilliary function that checks if a close enough
 * pixel clock is provided by the card. Returns clock number if
 * succesful (a special number if a programmable clock must be used), -1
 * otherwise.
 */
 
/*
 * Clock allowance in 1/1000ths. 10 (1%) corresponds to a 250 kHz
 * deviation at 25 MHz, 1 MHz at 100 MHz
 */

#define CLOCK_ALLOWANCE 10

#define PROGRAMMABLE_CLOCK_MAGIC_NUMBER 0x1234
 
static int findclock( int clock, CardSpecs *cardspecs ) {
	int i;
	for (i = 0; i < cardspecs->nClocks; i++) {
		int diff;
		diff = cardspecs->clocks[i] - clock;
		if (diff < 0)
			diff = -diff;
		if (diff * 1000 / clock < CLOCK_ALLOWANCE) 
			return i;
	}
	/* Try programmable clocks if available. */
	if (cardspecs->flags & CLOCK_PROGRAMMABLE) {
		int diff;
		diff = cardspecs->matchProgrammableClock(clock) - clock;
		if (diff < 0)
			diff = -diff;
		if (diff * 1000 / clock < CLOCK_ALLOWANCE)
			return PROGRAMMABLE_CLOCK_MAGIC_NUMBER;
	}
	/* No close enough clock found. */
	return -1;
}

int getmodetiming( ModeTiming *modetiming, ModeInfo *modeinfo,
CardSpecs *cardspecs ) {
	int maxclock, bestclock, desiredclock, i;
        MonitorModeTiming* usertiming;
        MonitorModeTiming* besttiming;
                    

#ifdef DEBUG
        printf("getmodetiming: for a %dx%d mode\n",
              modeinfo->width,modeinfo->height);  
#endif	
			
	/* Get the maximum pixel clock for the depth of the requested mode. */
	if (modeinfo->bitsPerPixel == 4)
		maxclock = cardspecs->maxPixelClock4bpp;
	else
	if (modeinfo->bitsPerPixel == 8)
		maxclock = cardspecs->maxPixelClock8bpp;
	else
	if (modeinfo->bitsPerPixel == 16) {
		if ((cardspecs->flags & NO_RGB16_565)
		&& modeinfo->greenWeight == 6)
			return 1;	/* No 5-6-5 RGB. */
		maxclock = cardspecs->maxPixelClock16bpp;
	}
	else
	if (modeinfo->bitsPerPixel == 24)
		maxclock = cardspecs->maxPixelClock24bpp;
	else
	if (modeinfo->bitsPerPixel == 32)
		maxclock = cardspecs->maxPixelClock32bpp;
	else
		maxclock = 0;

	/*
	 * bestclock is the highest pixel clock found for the resolution
	 * in the mode timings, within the spec of the card and
	 * monitor.
	 */
	bestclock = 0;

	/* Search the user timings for the best matching mode. */
	for (usertiming=user_timings;usertiming;usertiming=usertiming->nextinthelist ) {
		if (usertiming->HDisplay == modeinfo->width
		&& (usertiming->VDisplay == modeinfo->height
			|| ((usertiming->flags & DOUBLESCAN)
		  		&& usertiming->VDisplay ==
		  		modeinfo->height * 2))
		&& timing_within_monitor_spec(usertiming) 
		&& usertiming->pixelClock <= maxclock
		&& usertiming->pixelClock > bestclock
		&& cardspecs->mapHorizontalCrtc(modeinfo->bitsPerPixel,
			usertiming->pixelClock,
			usertiming->HTotal)
			<= cardspecs->maxHorizontalCrtc
		/* Find the clock (possibly scaled by mapClock). */
		&& findclock(cardspecs->mapClock(modeinfo->bitsPerPixel,
			usertiming->pixelClock), cardspecs) != -1
		) {
			bestclock = usertiming->pixelClock;
			besttiming = usertiming;
		}}
	if (bestclock == 0)  {
	/* no user timing found. try standard timing now  TMoor*/
#ifdef DEBUG
	  printf("no user timing found, using standard timings\n");
#endif	  
          for (i = 0; i < NUMBER_OF_STANDARD_MODES; i++)
		if (standard_timings[i].HDisplay == modeinfo->width
		&& (standard_timings[i].VDisplay == modeinfo->height
			|| ((standard_timings[i].flags & DOUBLESCAN)
		  		&& standard_timings[i].VDisplay ==
		  		modeinfo->height * 2))
		&& timing_within_monitor_spec(&(standard_timings[i]))
		&& standard_timings[i].pixelClock <= maxclock
		&& standard_timings[i].pixelClock > bestclock
		&& cardspecs->mapHorizontalCrtc(modeinfo->bitsPerPixel,
			standard_timings[i].pixelClock,
			standard_timings[i].HTotal)
			<= cardspecs->maxHorizontalCrtc
		/* Find the clock (possibly scaled by mapClock). */
		&& findclock(cardspecs->mapClock(modeinfo->bitsPerPixel,
			standard_timings[i].pixelClock), cardspecs) != -1
		) {
			bestclock = standard_timings[i].pixelClock;
			besttiming = &(standard_timings[i]);
		}
	}	
	if (bestclock == 0) {
#ifdef DEBUG
		printf("no timing found \n");
#endif
		return 1;
	}	

	/*
	 * Copy the selected timings into the result, which may
	 * be adjusted for the chipset.
	 */

#ifdef DEBUG  
	printf("use timing: %3.2f %d %d %d %d %d %d %d %d \n",
        besttiming->pixelClock / 1000.0,
        besttiming->HDisplay,besttiming->HSyncStart,besttiming->HSyncEnd,besttiming->HTotal,
        besttiming->VDisplay,besttiming->VSyncStart,besttiming->VSyncEnd,besttiming->VTotal);
#endif
	modetiming->flags = besttiming->flags;
	modetiming->pixelClock = bestclock;	/* Formal clock. */

	/*
	 * We know a close enough clock is available; the following is the
	 * exact clock that fits the mode. This is probably different
	 * from the best matching clock that will be programmed.
	 */

	desiredclock = cardspecs->mapClock(modeinfo->bitsPerPixel,
		besttiming->pixelClock),


	/* Fill in the best-matching clock that will be programmed. */
	modetiming->selectedClockNo = findclock(desiredclock, cardspecs);
	
	if (modetiming->selectedClockNo == PROGRAMMABLE_CLOCK_MAGIC_NUMBER) {
		modetiming->programmedClock =
			cardspecs->matchProgrammableClock(desiredclock);
		modetiming->flags |= USEPROGRCLOCK;
	}
	else
		modetiming->programmedClock = cardspecs->clocks[
			modetiming->selectedClockNo];
	modetiming->HDisplay = besttiming->HDisplay;
	modetiming->HSyncStart = besttiming->HSyncStart;
	modetiming->HSyncEnd = besttiming->HSyncEnd;
	modetiming->HTotal = besttiming->HTotal;
	if (cardspecs->mapHorizontalCrtc(modeinfo->bitsPerPixel,
			modetiming->programmedClock,
			besttiming->HTotal)
	!= besttiming->HTotal) {
		/* Horizontal CRTC timings are scaled in some way. */
		modetiming->CrtcHDisplay =
			cardspecs->mapHorizontalCrtc(modeinfo->bitsPerPixel,
				modetiming->programmedClock,
				besttiming->HDisplay);
		modetiming->CrtcHSyncStart =
			cardspecs->mapHorizontalCrtc(modeinfo->bitsPerPixel,
				modetiming->programmedClock,
				besttiming->HSyncStart);
		modetiming->CrtcHSyncEnd =
			cardspecs->mapHorizontalCrtc(modeinfo->bitsPerPixel,
				modetiming->programmedClock,
				besttiming->HSyncEnd);
		modetiming->CrtcHTotal =
			cardspecs->mapHorizontalCrtc(modeinfo->bitsPerPixel,
				modetiming->programmedClock,
				besttiming->HTotal);
		modetiming->flags |= HADJUSTED;
	}
	else {
		modetiming->CrtcHDisplay = besttiming->HDisplay;
		modetiming->CrtcHSyncStart = besttiming->HSyncStart;
		modetiming->CrtcHSyncEnd = besttiming->HSyncEnd;
		modetiming->CrtcHTotal = besttiming->HTotal;
	}
	modetiming->VDisplay = besttiming->VDisplay;
	modetiming->CrtcVDisplay = besttiming->VDisplay;
	modetiming->VSyncStart = besttiming->VSyncStart;
	modetiming->CrtcVSyncStart = besttiming->VSyncStart;
	modetiming->VSyncEnd = besttiming->VSyncEnd;
	modetiming->CrtcVSyncEnd = besttiming->VSyncEnd;
	modetiming->VTotal = besttiming->VTotal;
	modetiming->CrtcVTotal = besttiming->VTotal;
	if (((modetiming->flags & INTERLACED)
	&& (cardspecs->flags & INTERLACE_DIVIDE_VERT))
	|| (modetiming->VTotal >= 1024
	&& (cardspecs->flags & GREATER_1024_DIVIDE_VERT))) {
		/*
		 * Card requires vertical CRTC timing to be halved for
		 * interlaced modes, or for all modes with vertical
		 * timing >= 1024.
		 */
		modetiming->CrtcVDisplay /= 2;
		modetiming->CrtcVSyncStart /= 2;
		modetiming->CrtcVSyncEnd /= 2;
		modetiming->CrtcVTotal /= 2;
		modetiming->flags |= VADJUSTED;
	}
	return 0;	/* Succesful. */
}
