/* defs for the os2 version of dview */


#define XRES      300             /* set the default resulution in dpi (option -r) */
#define YRES      300

#define PAPXMM    210.0           /* set the default papersize in mm (option -p)*/
#define PAPYMM    297.0   

#define VGAXDIM 500               /* set the default window size (option -d) */
#define VGAYDIM 600		  

#define LRANDMM 4.0               /* define non printable space  (option -k) */
#define RRANDMM 4.0		  /* used for the frame "p" only      */
#define ORANDMM 4.0			
#define URANDMM 12.0

#define HOFFMM 25.4                /* location of the top left corner from */
#define VOFFMM 25.4		  /* the dvifile on the page (options -h -v)*/
 
 
#define DOSFILES

/* set defaults for the options -t, -f and -n */

#define TFMDIR  "C:\\EMTEX\\TFM"
#define PKDIR   ".\\;C:\\TEXFONTS\\PIXEL.LJ"
#define PKNAME  "@Mdpi\\@K.pk"


/* nothing to be changed below this line ? */

#define SMAX      100   /* stack size */
#define MAXFONTS 256


#define MAXPATHSTR 256
#define MAXPATHDEP 10
#define MAXLINMEM (2048*1024)



#define BMCHAR

#ifdef	BMLONG
#define	BMUNIT			unsigned long
#define	BITS_PER_BMUNIT		32
#define BITS_LOG2               5
#define	BYTES_PER_BMUNIT	4
#endif
#ifdef	BMSHORT
#define	BMUNIT			unsigned short
#define	BITS_PER_BMUNIT		16
#define BITS_LOG2               4
#define	BYTES_PER_BMUNIT	2
#endif
#ifdef BMCHAR
#define BMUNIT                  unsigned char
#define	BITS_PER_BMUNIT		8
#define BITS_LOG2               3
#define	BYTES_PER_BMUNIT	1
#endif


#define BLACKNWHITE 1

#define BITS_PER_GREY 4           /* must be a divisor of BITS_PER_BMUNIT */
#define COLORS_PER_GREY 16
#define BITS_PER_GREY_LOG2 2
#define GREYINBMU                 /* use this to waste memory */


#ifdef GREYINBMU
#define GREYSCALE BITS_PER_BMUNIT
#define GREYSCALE_LOG2 BITS_LOG2
#else
#define GREYSCALE BITS_PER_GREY
#define GREYSCALE_LOG2 BITS_PER_GREY_LOG2
#endif

/* ... nothing to be changed till here */


/* start up defaults and no gammacorrection */

#define GAMMA 1.2     /* GAMMA \in(0,\infty), larger GAMMA -> darker drawings */
	              /* set GAMMA to 1 for neutral greyscales. */

#define MAXSHRINK 15
#define SHRINK 3
#define PCOLORS GREYSCALE
#define MAXFINE 8
#define FINE 2



/* nothing to be changed below this line  ! */

#define uchar unsigned char
#define ushort unsigned short
#define uint unsigned int
#define ulong unsigned long
#define ptr void *


#define ROUNDUP(x,y) (((x)+(y)-1)/(y))
#define	ADD(a, b)	((BMUNIT *) (((char *) a) + b))
#define	SUB(a, b)	((BMUNIT *) (((char *) a) - b))
#define MIN(a, b)	((a)<(b)?(a):(b))
#define MAX(a, b)	((a)>(b)?(a):(b))

typedef struct bitmap {
	short w, h;		/* width and height in pixels */
	short bmu_wide;  	/* scan-line width in BMUNIT  */
	BMUNIT *bits;		/* pointer to the bits */
        char type;
} bitmap;

typedef struct bigbitmap {
        short w, h;
        short bmu_wide;
        BMUNIT **bits;         /*vector of  pointer to rows*/
        char type;
} bigbitmap;

typedef union chdesc { 
  struct { short hof, vof; bitmap bmp; long tfw, addr;uchar flag; 
           short hof2,vof2;bitmap bmp2; uchar shrink;} U1;
  struct { long tfh, tfw, tfd, dum1, dum2; } U2; 
} chdesc;

typedef struct fontdesc {
  long dfn;  char *fonam;  chdesc *chv;  short mch, fty; long scf;
} fontdesc;

#define PKTYPE 1
#define TFMTYPE 2
#define NOTYPE 0





#define NOP 100  /*<=100 is nop */
#define NEXT 101
#define PREV 102
#define QUIT 103
#define UP 104
#define DOWN 105
#define RIGHT 106
#define LEFT 107
#define CENTER 108
#define PLUS 109
#define MINUS 110
#define REDRAW 111
#define MOREFINE 112
#define LESSFINE 113
#define TOGO 114
#define FIRST 115
#define LAST 116
#define GOTO 117
#define TOFRAME 118
#define NUM0 200
#define NUM9 209
#define DELETE 210





































