/*
This is part of dview, a dvi previewer. (c) 1995 Thomas Moor


Once this was ...

(C)opyright 1994 Wolfgang R. Mueller, Computing Centre,
Heinrich-Heine-University Duesseldorf, Germany,
wolfgang@uni-duesseldorf.de, +49-211-311-3905.

... but this some months ago, and only a view lines of the original codes are
left.   

Feb. 95: by some modifications by Thomas Moor this became
a dvi viewer. All the fancy color-stuff was removed too. Sorry. 
Some ideas and of cause some lines of code are stolen from xdvi, which is 
written by Eric Cooper, who derived his program from dvi-imagen. The slow and 
ugly lines are mine.

Jul. 95: porting back to linux, using svgalib. Hacking arround with S3 chips
and making dview at least usable. there are still important things to be done,
especially the way memory is wasted should be changed. 

Sep. 95: now dview is at least some kind of usable. and tested on a few sites
too. so ill give to the people ?
 

This program may be used without any warranty. It may be modified and 
distributed without any restictions.

*/


#include <stdio.h>

#include "defs.h"


/* from the file globals.c we need ... */
extern char* dviname;
extern float hoffmm, voffmm;
extern float papxmm,papymm;
extern float lrandmm, rrandmm, orandmm, urandmm;
extern int xres,yres;
extern char* tfmprefix;
extern char* fontprefix;
extern char* fontformat;
extern long newmag;
extern FILE* prot;
extern int cpagenum;
extern int vgaxdim,vgaydim;
extern int dvixpos,dviypos;
extern int frameon;
extern uchar shrink;
extern uchar colors;
extern bigbitmap pxlmem;

/* from the file subs.c we need ... */
extern Tptr(void*);


/*from the file write*.c we need ... */
extern void vgaopen(void);
extern void vgaclose(void);
extern void vgaredraw(void);
extern void vgascroll(short,short);
extern uchar vgacommand(void);

/* from the file readdvi.c we  need ... */
extern void initdvi(void);
extern void killdvi(void);
extern int dopage(short,uchar,uchar);




main(int argc, char **argv) { 
  uchar o,redraw,cent;
  char *parm;
  int deltoff;
  int number;
  int i,j,k;
  long f;
  uchar fine;
  int ox,oy;

  prot=stdout; /* for god sake */
  /* prot=fopen("prot","w"); /* better ist this ... */

  fprintf(prot, "This is some kind of a DVIewer, V 95.10 .\n");
  fprintf(prot, "(C)opyright 1995 Thomas Moor\n");

      
  newmag = 0;    
  hoffmm = HOFFMM;  
  voffmm = HOFFMM;  
  Tptr(tfmprefix=(char*) malloc(MAXPATHSTR));
  Tptr(fontprefix=(char*) malloc(MAXPATHSTR));
  Tptr(fontformat=(char*) malloc(MAXPATHSTR));
  Tptr(dviname=(char*) malloc(MAXPATHSTR));
  sprintf(fontprefix,PKDIR);
  sprintf(fontformat,PKNAME);
  sprintf(tfmprefix,TFMDIR);
  /*env=getenv("DVIDRVFONTS");
  if(env!=NULL) strcpy(fontprefix,env);
  env=getenv("TEXTFM");
  if(env!=NULL) strcpy(tfmprefix,env); */
  vgaxdim=VGAXDIM;
  vgaydim=VGAYDIM;
  papxmm=PAPXMM;
  papymm=PAPYMM;
  lrandmm=LRANDMM;
  rrandmm=RRANDMM;
  orandmm=ORANDMM;
  urandmm=URANDMM;
  xres=XRES;
  yres=YRES;
  if (argc == 1) {
    fprintf(prot, "use with dvifilename and optional parameters\n");
    fprintf(prot, " -h<horizontal offset>   (default: %5.1f mm)\n", hoffmm);
    fprintf(prot, " -v<vertical offset>     (default: %5.1f mm)\n", voffmm);
    fprintf(prot, " -p<paperwidth>x<height> (default: %5.1fx%5.1f mm**2)\n",
                                                      papxmm,papymm);
    fprintf(prot, " -r<xres>x<yres>         (default: %dx%d dpi**2)\n",
                                                      xres,yres);
    fprintf(prot, " -f<font directory>      (default: %s)\n", fontprefix);
    fprintf(prot, " -n<font name format>    (default: %s)\n", fontformat); 
    fprintf(prot, " -t<TFMfile directory>   (default: %s)\n", tfmprefix);
    fprintf(prot, " -d<diplaywidth>x<height>(default: %dx%d pxl**2)\n",
                                                      vgaxdim,vgaydim);
    fprintf(prot, " -m<new magnification>   (default: from DVIfile)\n");
    fprintf(prot, " -k<lr>,<rr>,<or>,<ur>   (default: %2.1f,%2.1f,%2.1f,%2.1f mm)\n",
                                                      lrandmm,rrandmm,orandmm,urandmm);
    exit(0);
  }
  for (j = 1; j < argc; j++) {  parm = argv[j];
    if (parm[0] != '-') {  strcpy(dviname, parm);
    } else {  switch (parm[1]) {
      case 'f':  case 'F':  strcpy(fontprefix, parm+2);  break;
      case 'n':  case 'N':  strcpy(fontformat, parm+2);  break;
      case 't':  case 'T':  strcpy(tfmprefix, parm+2);  break;
      case 'm':  case 'M':  sscanf(parm+2, "%ld", &newmag);  break;
      case 'h':  case 'H':  sscanf(parm+2, "%f", &hoffmm);  break;
      case 'v':  case 'V':  sscanf(parm+2, "%f", &voffmm);  break;
      case 'd':  case 'D':  sscanf(parm+2, "%dx%d", &vgaxdim,&vgaydim); break;
      case 'p':  case 'P':  sscanf(parm+2, "%fx%f", &papxmm,&papymm); break;
      case 'r':  case 'R':  sscanf(parm+2, "%dx%d", &xres,&yres); break;
      case 'k':  case 'K':  sscanf(parm+2, "%f,%f,%f,%f", &lrandmm,&rrandmm,&orandmm,&urandmm); break;
  } } }
  vgaopen();
  shrink=SHRINK;
  colors=PCOLORS;
  fine=FINE;
  cpagenum=0;
  frameon=0;
  dvixpos=(papxmm/25.4* xres /shrink -vgaxdim)/2; 
  dviypos=(papymm/25.4* yres /shrink -vgaydim)/2; 
  number=0;
  o=REDRAW;
  cent=0;
  do{
    redraw=0;
    deltoff=vgaxdim/(1<<fine)+1;
    switch(o) {
      case REDRAW:
        killdvi();
        initdvi();
        redraw=dopage(cpagenum,shrink,colors);
        break;
      case NEXT:
        redraw=dopage(cpagenum+1,shrink,colors); break;
      case PREV:
        redraw=dopage(cpagenum-1,shrink,colors); break;
      case RIGHT:
        if(dvixpos+deltoff<pxlmem.w-50) {
          dvixpos+=deltoff;
          vgascroll(-deltoff,0);
        }; break;
      case LEFT:
        if(dvixpos-deltoff+vgaxdim >= 50) {
          dvixpos-=deltoff;
          vgascroll(deltoff,0);
        }; break; 
      case DOWN:
        if(dviypos+deltoff<pxlmem.h-50) {
          dviypos+=deltoff;
          vgascroll(0,-deltoff);
        }; break;
      case UP:
        if(dviypos-deltoff+vgaydim >= 50) {
          dviypos-=deltoff;
          vgascroll(0,+deltoff);
        }; break;
      case CENTER:
        if(!cent) {
           ox=dvixpos;
           dvixpos=(pxlmem.w-vgaxdim)/2;
           vgascroll(ox-dvixpos,0);
           cent=1;
        } else { 
           oy=dviypos;
           dviypos=(pxlmem.h-vgaydim)/2;
           vgascroll(oy-dviypos,0);
           cent=0;
	};
        break;
      case MINUS:
        redraw=dopage(cpagenum,shrink+1,colors); 
        if(redraw) {
          dvixpos=(shrink-1)/(float) shrink*(dvixpos+vgaxdim/2)-vgaxdim/2;
          dviypos=(shrink-1)/(float) shrink*(dviypos+vgaydim/2)-vgaydim/2;
        } 
        break;
      case PLUS:
        redraw=dopage(cpagenum,shrink-1,colors);
        if(redraw) {
          dvixpos=(shrink+1)/ (float) shrink*(dvixpos+vgaxdim/2)-vgaxdim/2;
          dviypos=(shrink+1)/ (float) shrink*(dviypos+vgaydim/2)-vgaydim/2;
        } 
        break;
      case MOREFINE:
        fine=MIN(MAXFINE,fine+1); break;
      case LESSFINE:
        fine=MAX(1,fine-1); break;
      case TOGO:
        if(colors==BLACKNWHITE) redraw=dopage(cpagenum,shrink,GREYSCALE);
        else redraw=dopage(cpagenum,shrink,BLACKNWHITE);
        break;
      case TOFRAME:
        frameon=1-frameon;
        redraw=1;
        break;
      case FIRST:
        redraw=dopage(0,shrink,colors); break;
      case LAST:
        redraw=dopage(9999,shrink,colors); break;
      case GOTO:
        redraw=dopage(number,shrink,colors); break;
      case DELETE:
        number=number/10; break;
      default:
      if((o>=NUM0) && (o<=NUM9)) 
        number= number*10+o-NUM0;
    }  
    if(redraw) vgaredraw();
    if((o!=CENTER) && (o>NOP)) cent=0;
    if((o>NOP) && (o<NUM0)) number=0;
    o=vgacommand();
  }while(o != QUIT);
   
  fprintf(prot,"\n"); 
  killdvi(); 
  vgaclose(); 
  exit(0);
}













