/* This is part of dview, a dvi previewer. (c) 1995 Thomas Moor          */
/*                                                                       */
/* This program may be used without any warranty. It may be modified and */
/* distributed without any restrictions.                                 */

#include <stdio.h>
#include "defs.h"



/* we do need from the file globals.c ... */
extern FILE* prot;
extern fontdesc ** fontvect;
extern uchar shrink;
extern uchar colors;
extern BMUNIT* bit_masks;
extern uchar* bit_count;
extern uchar* greytab;
extern char* fontformat;

/* eliu  jolhfi eeeeeeefih subs.c */
extern long scaled(long,long);
extern void* findmem(long int);
extern void alloc_bitmap(bitmap*);
extern void clear_bitmap(bitmap*);
extern void print_bitmap(bitmap*);
extern void draw_frame(bitmap*);
extern int msearch(char*, char*, char*);



FILE* pkfile;
unsigned pkactbyte; 
int pkbitpos, pkdynf, pkrepcount;


void pkopen(char* fname) {
  if((pkfile = fopen(fname, "rb"))==0) {
    fprintf(prot,"\n fatal error: pk-file disapeard. \n");
    exit(1);
  }
}


#define pkclose()  fclose(pkfile)
#define pkskip(delta) fseek(pkfile,delta,1)
#define pkposit(to) fseek(pkfile,to,0)
#define pktell()  ftell(pkfile)


#define pkn1() (uchar) fgetc(pkfile)


short pkn2()  {  
  short b;
  b = pkn1();  
  return (b * 256 + pkn1());
}

long pkn3()  {  
  long b;  
  short c;
  b = pkn1();  
  c = pkn1();
  return ((b * 256 + c) * 256 + pkn1());
}


unsigned long pkn4()  {  
  unsigned long b,c,d;  
  b = pkn1();  
  c = pkn1();
  d = pkn1();
  return (((b * 256 + c) * 256 +d)*256+ pkn1());
}


short pki1()  {  
  short b;
  b = pkn1();  
  if (b > 127)  b -= 256;  
  return b;
}

short pki2()  {  
  short b;
  b = pkn1();  
  if (b > 127)  b -= 256;
  return (b * 256 + pkn1());
}

long pki3()  {  
  long b;
  b = pki1();  return (b * 65536L + pkn2());
}

long pki4()  {  
  long b;
  b = pki2();  
  return (b * 65536L + pkn2());
}

int pknib(void)  {  
  unsigned Result;
  if (pkbitpos <0) {
    pkactbyte = pkn1();  
    pkbitpos=4;
  }
  Result= pkactbyte >> pkbitpos;  
  pkbitpos -= 4;
  /*fprintf(prot,"(pknib: n %d p %d)",Result & 0xf,pkbitpos);*/
  return (Result & 0x0f);
}


int pkpackednum(void){
  int  i,j;
  /*fprintf(prot,"pkpackednum? ");*/
  if ((i = pknib()) == 0) {
    do {
      j = pknib();
      ++i;
    } while (j == 0);
    while (i > 0) {
      j = (j << 4) | pknib();
      --i;
    }
    return (j - 15 + ((13 - pkdynf) << 4) + pkdynf);
  } else {
    if (i <= pkdynf) return i;
    if (i < 14) return (((i - pkdynf - 1) << 4) + pknib() + pkdynf + 1);
    if (i == 14) pkrepcount = pkpackednum();
    else pkrepcount = 1;
    return pkpackednum();
  }
}


setpkname(char* fn, float fm, int delta, char* result) {
  char buff[MAXPATHSTR];
  int i,j;

  /*fprintf(prot,"(setpkname: %s ",fontformat);*/
  i=0;
  *result=0;
  while(1) {
    /*fprintf(prot,"%s ",result);*/
    j=i;
    for(;(fontformat[i] != 0) && (fontformat[i] != '@');i++);
    strncat(result,fontformat+j,i-j);
    if(fontformat[i] == 0) break;
    i++;
    switch(fontformat[i]){
    case 'm': case 'M':
      sprintf(buff,"%ld",(long)(fm+0.5)+delta);
      break;
    case 'r': case 'R':
      sprintf(buff,"%ld",(long)(5*fm+0.5)+delta);
      break;
    case 'n': case 'N':
      strcpy(buff,fn);
      break;
    case 'k': case 'K':
      strncpy(buff,fn,8);
      break;
    default:
      *buff=0;
    }
    strcat(result,buff);
    i++;
  }
  /*fprintf(prot,"%s)",ffname);*/
}

int pkfind(char* ffpath,char* fontname,float fontmag,char* fftuto)  {  
  char ffname[MAXPATHSTR];
  int delta, foundfile;
  FILE* fofile;

  setpkname(fontname,fontmag,0,ffname);
  fprintf(prot,"preparing font: %s", ffname);
  foundfile=msearch(ffpath,ffname,fftuto);

  if(foundfile==0) {  
    fprintf(prot, " - file not found !\n");  
    for(delta=(int)(-0.002*fontmag) -1; delta<=(int)(0.002*fontmag)+1;delta++){
       if(delta==0) delta=1;
       setpkname(fontname,fontmag,delta,ffname);
       fprintf(prot,"resize        : %s", ffname);
       foundfile=msearch(ffpath,ffname,fftuto);
       if(foundfile==0) 
         fprintf(prot, " - file not found !\n"); 
       else 
         break;
     }
  }
  if(foundfile==0) return(0);
  fofile=fopen(fftuto,"rb");
  if ((fgetc(fofile)!=0xf7)||(fgetc(fofile)!=0x59)){  
    fprintf(prot, " - not a PKfile !\n");  
    fclose(fofile);
    return(0);
  }
  fclose(fofile);
  return(1);
} 


int pkdef(char* fftuto,int fontintnr,long chksum)  {  
  long a, l, dchksum;  
  uchar b, bb;
  uchar terminate;  short i, j, c;  
  fontdesc *font;  
  chdesc *achar;
  
  font = fontvect[fontintnr];
  font->mch = -1;  
  font->fonam = (char *) findmem(strlen(fftuto)+1);
  strcpy(font->fonam, fftuto);
  font->chv=(chdesc *)findmem(256 * sizeof(chdesc));
  memset(font->chv,0,256 * sizeof(chdesc));             /* why ?? */
  pkopen(fftuto);
  terminate = 0;
  do {  b = pkn1();
    if (b >= 240) {
    switch (b) {
    case 240:  case 241:  case 242:  case 243:    /*skip specials */
      l = 0;
      for (i = 240; i <= b; i++)  l = (l << 8) + pkn1();
      pkskip(l);  
      break;
    case 244:  pkskip(4L);  break;
    case 245:  terminate = 1;  break;
    case 246:  break;
    case 247:  
      b = pkn1();  i = pkn1();
      pkskip((long) i + 4);  dchksum = pki4();
      if (chksum != 0) if (dchksum != 0) if (chksum != dchksum)
      fprintf(prot, " *+* wrong checksum *+* ");
      pkskip(8L);  break;
    case 248:  case 249:  case 250:  case 251:
    case 252:  case 253:  case 254:  case 255:  break;
    }
  } else {  
    bb = b & 7;
    switch (bb) {
    case 0:  case 1:  case 2:  case 3:
      l = (bb << 8) + pkn1();  c = pkn1();  break;
    case 4:  case 5:  case 6:  l = bb - 4;
      l = ((bb -4) << 16) + pkn2();  c = pkn1();  break;
    case 7:  l = pki4();  c = pki4();  break;
    }
    if(c>255) {
       fprintf(prot," -  heavy pkfile: charactercodes > 255 not supportet.\n");
       free(font->chv);
       font->chv = NULL;
       return(0);
    }
    achar = &font->chv[c];
    achar->U1.addr = pktell();
    achar->U1.flag = b;
    achar->U1.bmp.bits = NULL;      /* for safty only */
    achar->U1.bmp2.bits = NULL;
    pkskip(l); 
    if (font->mch < c)  font->mch = c; 
  }
  } while (!terminate); 
  if (font->mch < 0) {
    fprintf(prot, " - PKfile in error !\n");
    free(font->chv);
    font->chv=NULL;
    return(0);
  } else  fprintf(prot, " - available\n");
  font->chv = (chdesc *) realloc(font->chv, sizeof(chdesc)*(font->mch + 1));
  font->fty = PKTYPE;
  return(1);
}





pkloadchar(uchar ch, int fontintnr){

	int	 n;
        fontdesc *font;
	chdesc   *thechar;
        uchar    theflag;
	long	 fpwidth;
        unsigned long w,h;
         
        char	paint_switch;
	int	i, j;
	int	row_bit_pos;
	BMUNIT	*cp;
	BMUNIT	word;
	int	word_weight, bytes_wide;
	int	rows_left, h_bit, count;

        font=fontvect[fontintnr];
        /* fprintf(prot,"(pkloadchar: font %s char %d ",font->fonam,ch);*/
        pkopen(font->fonam);
	thechar= &font->chv[ch];
        pkposit(thechar->U1.addr);
	theflag = thechar->U1.flag;
	pkdynf = theflag  >> 4;
	paint_switch = ((theflag & 8) != 0);
	theflag &= 0x7;

	/*
	 * now read rest of character preamble
	 */
        switch (theflag) {
        case 0:  case 1:  case 2:  case 3:
          fpwidth = pkn3();  pkn1();
          w = pkn1(); h = pkn1();
          thechar->U1.hof = pki1();  thechar->U1.vof = pki1();  break;
        case 4:  case 5:  case 6:
          fpwidth = pkn3();  pkn2();
          w = pkn2(); h = pkn2();
          thechar->U1.hof = pki2();  thechar->U1.vof = pki2();  break;
        case 7:
          fpwidth = pki4();  pki4(); pki4();
          w = pkn4();  h = pkn4();
          thechar->U1.hof = pki4();  thechar->U1.vof = pki4();  break;
        }
        if (w > 0x7fff || h > 0x7fff || 
           (h*(ROUNDUP(w,BITS_PER_BMUNIT)*BYTES_PER_BMUNIT) > MAXLINMEM  )){
	  fprintf(prot,
          "\npkloadchar: fatal error: character %d too large in file %s \n",
          ch, font->fonam);
          exit(1);
        }
        thechar->U1.bmp.w = w;  thechar->U1.bmp.h = h; 
        thechar->U1.bmp.type=BLACKNWHITE;
        thechar->U1.tfw = scaled(fpwidth,font->scf);
        /*fprintf(prot,"tfw %d fpw %d scf %d ",thechar->U1.tfw,
         fpwidth,font->scf);
        fprintf(prot,"width %d hight %d hof %d vof %d ",
                 w,h,thechar->U1.hof,thechar->U1.vof); */
        
	alloc_bitmap(&thechar->U1.bmp);
	cp = thechar->U1.bmp.bits;

	/*
	 * read character data into *cp
	 */

       
        bytes_wide = thechar->U1.bmp.bmu_wide * BYTES_PER_BMUNIT;
	pkbitpos = -1;
	if (pkdynf == 14) {	/* get raster by bits */
	    /* fprintf(prot,"raster: "); */
            clear_bitmap(&thechar->U1.bmp);
	    for (i = 0; i < thechar->U1.bmp.h; i++) {	/* get all rows */
		cp = ADD(thechar->U1.bmp.bits, i * bytes_wide);
		row_bit_pos = BITS_PER_BMUNIT;
		for (j = 0; j < thechar->U1.bmp.w; j++) {  /* get one row */
		    if (--pkbitpos < 0) {
			word = pkn1();
			pkbitpos = 7;
		    }
		    if (--row_bit_pos < 0) {
			cp++;
			row_bit_pos = BITS_PER_BMUNIT - 1;
		    }
		    if (word & (1 << pkbitpos)) *cp |= 1 << row_bit_pos;
		}
	    }
	}
	else {		/* get packed raster */
	    /*fprintf(prot,"packed raster ")*/;
            rows_left = thechar->U1.bmp.h;
	    h_bit = thechar->U1.bmp.w;
	    pkrepcount = 0;
	    word_weight = BITS_PER_BMUNIT;
	    word = 0;
	    while (rows_left > 0) {
	      /*fprintf(prot,"rl %d ",rows_left);*/
	      count = pkpackednum();
              while (count > 0) {
              /*fprintf(prot,"ct %d hb %d ww %d ",count,h_bit,word_weight);*/
	      if (count < word_weight && count < h_bit) {
	      	h_bit -= count;
	       	word_weight -= count;
	       	if (paint_switch)
        	  word |= bit_masks[count] << word_weight;
		  count = 0;
	      }
	      else if (count >= h_bit && h_bit <= word_weight) {
		if (paint_switch)
		word |= bit_masks[h_bit] << (word_weight - h_bit);
		*cp++ = word;
		/* "output" row(s) */
		for (i = pkrepcount * bytes_wide /
                           BYTES_PER_BMUNIT; i > 0; --i) {
		  *cp = *SUB(cp, bytes_wide);
		   ++cp;
		}
		rows_left -= pkrepcount + 1;
		pkrepcount = 0;
		word = 0;
		word_weight = BITS_PER_BMUNIT;
		count -= h_bit;
		h_bit = thechar->U1.bmp.w;
	      } else {
		if (paint_switch) word |= bit_masks[word_weight];
	 	  *cp++ = word;
		word = 0;
		count -= word_weight;
	        h_bit -= word_weight;
		word_weight = BITS_PER_BMUNIT;
	        }
	      }
	      paint_switch = 1 - paint_switch;
	    }
	    if (cp != (BMUNIT*)
              ((uchar*) thechar->U1.bmp.bits + bytes_wide * thechar->U1.bmp.h)){
       	      fprintf(prot,"Wrong number of bits stored:  char. %d, font %s",
                      ch,font->fonam);
              exit(1);
            }
	    if (rows_left != 0 || h_bit != thechar->U1.bmp.w) {
	      fprintf(prot,"Bad pk file (%s), too many bits", 
                       font->fonam);
              exit(1);
            }
	}
        pkclose();
        /*print_bitmap(&thechar->U1.bmp);*/
        /*fprintf(prot,")"); */
}

int sample(BMUNIT* bits,int bmu_wide,int bitskip,int w, int h) {
  BMUNIT *p, *endp;
  register BMUNIT *cp;
  int bitsleft;
  register int n,bitshift,wid;
  
  p=bits+bitskip/BITS_PER_BMUNIT;
  endp=bits+h*bmu_wide;
  bitsleft=w;
  bitshift=BITS_PER_BMUNIT- bitskip % BITS_PER_BMUNIT;
  n=0;
  while(bitsleft) {
    wid=bitshift;
    if(wid>bitsleft) wid=bitsleft;
    if(wid>8) wid=8;
    bitshift-=wid;
    for(cp=p;cp<endp;cp+=bmu_wide) 
      n+=bit_count[(*cp >> bitshift) & bit_masks[wid]];
    if(bitshift==0) {
      bitshift=BITS_PER_BMUNIT;
      ++p;
    }
    bitsleft -= wid;
  }
  return n;
}
  


void pkshrinkchar(chdesc* theChar) {
  int rowsleft, rows, colsleft, initcols;
  register int cols;
  int shrunkbuw,shrunkh;
  BMUNIT  *oldp, *newp;
  register BMUNIT m,*cp;
  int blevel=shrink*shrink/4;

  if(theChar->U1.bmp2.bits != 0) free(theChar->U1.bmp2.bits);
  theChar->U1.hof2=theChar->U1.hof / shrink;
  initcols=theChar->U1.hof-theChar->U1.hof2*shrink;
  if(initcols <=0) initcols+=shrink; else ++theChar->U1.hof2;
  theChar->U1.bmp2.w = theChar->U1.hof2 + 
    ROUNDUP(theChar->U1.bmp.w - theChar->U1.hof,shrink);
  cols=theChar->U1.vof +1;      /* buffer cols */
  theChar->U1.vof2 = cols / shrink;
  rows=cols-theChar->U1.vof2*shrink;
  if(rows <= 0) {
    rows+=shrink;
    --theChar->U1.vof2;
  }
  theChar->U1.bmp2.h=shrunkh=theChar->U1.vof2 +
    ROUNDUP(theChar->U1.bmp.h-cols,shrink) +1;
  theChar->U1.bmp2.type=colors;
  alloc_bitmap(&theChar->U1.bmp2);
  oldp=theChar->U1.bmp.bits;
  if(oldp==NULL) {
    fprintf(prot,"\nfatal error: my ugly memory management. sorry\n");
    exit(1);
  }
  newp=theChar->U1.bmp2.bits;
  shrunkbuw=theChar->U1.bmp2.bmu_wide;
  rowsleft=theChar->U1.bmp.h;
  memset(newp,0,BYTES_PER_BMUNIT*shrunkbuw*shrunkh);
  if(colors==BLACKNWHITE) {
  while(rowsleft) {
    if(rows>rowsleft) rows=rowsleft;
    colsleft=theChar->U1.bmp.w;
    m=(1 << (BITS_PER_BMUNIT -1));
    cp=newp;
    cols=initcols;
    while(colsleft){
      if(cols>colsleft) cols=colsleft;
      if(sample(oldp,theChar->U1.bmp.bmu_wide,theChar->U1.bmp.w-colsleft,
                cols,rows)>=blevel) *cp|=m;
      if(m==1) {
        m=(1 << (BITS_PER_BMUNIT -1));
        ++cp;
      } else m >>=1;
      colsleft-=cols;
      cols=shrink;
    }
    newp+=shrunkbuw;
    oldp+=rows*theChar->U1.bmp.bmu_wide;
    rowsleft-=rows;
    rows=shrink;
  }} else {             /* this is two in one: now GREY16 */
  while(rowsleft) {
    if(rows>rowsleft) rows=rowsleft;
    colsleft=theChar->U1.bmp.w;
    m= BITS_PER_BMUNIT -colors;
    cp=newp;
    cols=initcols;
    while(colsleft){
      if(cols>colsleft) cols=colsleft;
      *cp |= 
        greytab[(sample(oldp,theChar->U1.bmp.bmu_wide,
           theChar->U1.bmp.w-colsleft, cols,rows))]  << m;
      if(m) m-=colors;
      else {
        m=BITS_PER_BMUNIT -colors;
        ++cp;
      };
      colsleft-=cols;
      cols=shrink;
    }
    newp+=shrunkbuw;
    oldp+=rows*theChar->U1.bmp.bmu_wide;
    rowsleft-=rows;
    rows=shrink;
  }}
  theChar->U1.vof2=theChar->U1.vof/shrink;
  theChar->U1.shrink=shrink;
  /*print_bitmap(&(theChar->U1.bmp));
  print_bitmap(&(theChar->U1.bmp2));*/
}




