/* This is part of dview, a dvi previewer. (c) 1995 Thomas Moor          */
/*                                                                       */
/* This program may be used without any warranty. It may be modified and */
/* distributed without any restrictions.                                 */


#include <stdio.h>
#include "defs.h"

/* from the file globals.c we take ... */
extern fontdesc ** fontvect;
extern FILE* prot;

/* from the file subs.c we need ... */
extern int msearch(char*, char*, char*);
extern void* findmem(long);


FILE *fofile;

static uchar fofbyte() {  uchar b;
  if (fread(&b, 1, 1, fofile) <= 0) b = 0;  return b;
}

static long fofint(b)  uchar b;  {  uchar i;  long n;
  n = fofbyte();  if (n > 127)  n -= 256;
  for (i = 2; i <= b; i++)  n = (n << 8) | fofbyte();
  return n;
}

int tfmfind(char *ffpath,char *fontname,char *fftotal) {  
  char ffname[MAXPATHSTR];
  sprintf(ffname, "%s.tfm", fontname);
  fprintf(prot, "trying  %s  instead", ffname);
  if(! msearch(ffpath,ffname,fftotal)){
     fprintf(prot, " - absent as well \n");
     return(0); 
  } 
  return(1);
}


int tfmdef(char *fftotal,int fontintnr,long chksum) {  
  short ll, lh, bc, ec, nw, nh, nd, i;
  uchar b1, b2, b3;  short FORLIM;
  long fofchk;
  fontdesc *WITH = fontvect[fontintnr];
  fofile = fopen(fftotal, "rb");
  if (fofile==0)   return(0);  /*this cant happen */
  ll = fofint(2);  
  lh = fofint(2);  
  bc = fofint(2);  
  ec = fofint(2);
  nw = fofint(2);  
  nh = fofint(2);  
  nd = fofint(2);  
  fseek(fofile, 0L, 2);
  if (ll * 4 > ftell(fofile) || ll < lh + ec - bc + nw + nh + nd + 7) {
    fprintf(prot, " - not a TFMfile !\n");  
    fclose(fofile);  
    return(0);
  }
  WITH->mch = ec;
  WITH->chv = (chdesc *) findmem((WITH->mch + 1) *sizeof(chdesc));
  memset(WITH->chv,0,(WITH->mch + 1) *sizeof(chdesc));
  fseek(fofile, 24L, 0);  
  fofchk = fofint(4);
  if (chksum != 0) if (fofchk != 0) if (chksum != fofchk)
    fprintf(prot, " *+* wrong checksum *+* ");
  fseek(fofile, (lh + ec - bc + 7L) * 4, 0);
  FORLIM = nw + nh + nd;
  for (i = 0; i < FORLIM; i++)
    WITH->chv[i].U2.dum1 = scaled(fofint(4), WITH->scf);
  fseek(fofile, lh * 4L + 24, 0);
  for (i = bc; i <= ec; i++) {
    b1 = fofbyte();  b2 = fofbyte();  fofbyte();  fofbyte();
    WITH->chv[i].U2.tfw = WITH->chv[b1].U2.dum1;
    WITH->chv[i].U2.tfh = WITH->chv[nw + (b2 >> 4)].U2.dum1;
    WITH->chv[i].U2.tfd = WITH->chv[nw + nh + (b2 & 15)].U2.dum1;
  }
  fclose(fofile);  
  WITH->fty = TFMTYPE;  
  fprintf(prot, " - TFMfile OK\n");
  return(1);
}

