/* This is part of dview, a dvi previewer. (c) 1995 Thomas Moor          */
/*                                                                       */
/* This program may be used without any warranty. It may be modified and */
/* distributed without any restrictions.                                 */


#include <stdio.h>
#include <stdlib.h>


#ifdef __unix__
#include <dirent.h>
#endif

#include "defs.h"


/* from globals.c  we use ..*/
extern bigbitmap pxlmem;
extern FILE* prot;
extern BMUNIT* bit_masks;
extern fontdesc **fontvect;

long scaled(w, z)  long w, z;  {  long s; ulong t=w, u=z;
  /* should return  w * z / 2**20  */
  s = ( ( (((t & 65535L) * (u & 65535L)) >> 16)
	+   (t & 65535L) * (u >>    16)
	+   (t >>    16) * (u & 65535L)         ) >> 4)
    + ( (   (t >>    16) * (u >>    16)         ) << 12);
  if (w < 0)  s -= z << 12;  return s;
}



/*  one day here will be a kind of memorymenagement !*/

void Tptr(void *p) {  
  if(p==NULL) {
    fprintf(prot, " - not enough memory :-( "); exit(1);
  } 
}

void killfontbmp(int fintnr) {
  int c;

  if (fontvect[fintnr] != NULL) {
    if (fontvect[fintnr]->fty==PKTYPE) {
      fprintf(prot,"(dispose bitmaps of %d )",fintnr);
      for(c=0;c<=fontvect[fintnr]->mch;c++) {
	if(fontvect[fintnr]->chv[c].U1.bmp.bits != NULL) { 
          free(fontvect[fintnr]->chv[c].U1.bmp.bits);
          fontvect[fintnr]->chv[c].U1.bmp.bits = NULL;
        }
        if(fontvect[fintnr]->chv[c].U1.bmp2.bits != NULL) { 
          free(fontvect[fintnr]->chv[c].U1.bmp2.bits);
          fontvect[fintnr]->chv[c].U1.bmp2.bits = NULL;
        }
      }
    }
  }
}


/*   a what ?     */

static long memstat=0;
static int killnext=0;

void* findmem(long anz) { 
  int b;
  void* res;
  if((res = (void *) malloc(anz)) != NULL) return(res);  
  killnext++;
  b=killnext;
  while((res = (void *) malloc(anz)) == NULL) {
    killfontbmp(b);
    b++;
    if(b==MAXFONTS) b=0;                       
    if(b==killnext) break;
  }
  Tptr(res);
  return(res);
}



/* recursive directory searching ... 
   ... and theyre telling everyone that i, thomas moor, dont know too much
   about exaiming directories. and they are the reason off the very slow
   starting up. workaround: name the directories to be scanned explicietly,
   first, separeted by colons, followed by those,which are eventually to be
   scanned recursivly. */ 

#ifndef DOSFILES

int rsearch(char* done,char* path,int dep) {
  char ndone[MAXPATHSTR], npath[MAXPATHSTR];
  FILE* testfile;
  DIR *thisdir, *testdir;
  struct dirent *thisentry;
  int i,dn,sep,ndep;

  sep=-1;
  for(i=0;sep== -1 && path[i] != 0 ;i++) 
    if(path[i]=='/' ) if (path[i+1]=='/') {
      sep=i;
    }
  
  if(sep==-1) {
    strcat(done,path);
    testfile = fopen(done,"rb");
    if(testfile != NULL) {
      fclose(testfile);
      return(1);
    }
    return(0);
  }
  
  if(sep > 0) {
    strncat(done,path,sep);
    return(rsearch(done,path+sep,0));
  }

  dn=strlen(done);

  if(sep==0 && dep < MAXPATHDEP) { 
      if(rsearch(done,path+1,dep))  return(1);
      done[dn]=0;
      if ((thisdir=opendir(done))==NULL) return(0);
      while(thisentry=readdir(thisdir))
        if(    (strcmp(thisentry->d_name,".") != 0)
           && (strcmp(thisentry->d_name,"..") != 0)
           && (strlen(thisentry->d_name)+dn+2 < MAXPATHSTR) ){   
          done[dn]='/';
          strcpy(done+dn+1,thisentry->d_name);     
	  if((testdir=opendir(done))!= NULL) {
            closedir(testdir);
            if(rsearch(done,path,dep+1)) {
              closedir(thisdir);
              return(1);
            }
          }
          done[dn]=0;
        }
    closedir(thisdir);
    return(0);
  }
}
          

int msearch(char* mpath,char* filename,char* result) {
  int mpnpo, pnpo,hopo, found;
  char pn[MAXPATHSTR];
  char* homedir;
  char ch;
 
  
  homedir = getenv("HOME");
  if(homedir == NULL) homedir="/home_not_def";
  if(strlen(homedir) + strlen(mpath) + 1 >MAXPATHSTR) return(0);
  mpnpo=0;
  while (mpath[mpnpo]== ':') mpnpo++;
  found=0;
  while(mpath[mpnpo] != 0) {
    pnpo=0;
    if(mpath[mpnpo] == '~' && 
       (mpath[mpnpo+1]==':' || mpath[mpnpo+1]=='/' || mpath[mpnpo+1]==0)) { 
      for(hopo=0;homedir[hopo] != 0;hopo++)
          pn[pnpo++]=homedir[hopo];
      mpnpo++;
      if(pn[pnpo-1]=='/' && mpath[mpnpo]=='/') mpnpo++; 
    }
    while((mpath[mpnpo] != ':') && (mpath[mpnpo] != 0)) 
      pn[pnpo++]=mpath[mpnpo++];
    while (mpath[mpnpo]== ':') mpnpo++;
    if(pnpo>0){
      if(pn[pnpo-1] != '/') pn[pnpo++]='/';
      pn[pnpo]=0;
      strcat(pn,filename);
      result[0]=0;
      if(rsearch(result,pn,0)) return(1); 
    }
  }
  return(0);
}


#else   /*ifdef DOSFILES */

int msearch(char* mpath,char* filename,char* result) {
  int mpnpo, pnpo,hopo;
  char ch;
  FILE* test;
  
  if(strlen(mpath) + 1 >MAXPATHSTR) return(0);
  mpnpo=0;
  while (mpath[mpnpo]== ';') mpnpo++;
  while(mpath[mpnpo] != 0) {
    pnpo=0;
    while((mpath[mpnpo] != ';') && (mpath[mpnpo] != 0)) 
      result[pnpo++]=mpath[mpnpo++];
    while (mpath[mpnpo]== ';') mpnpo++;
    if(pnpo>0){
      if(result[pnpo-1] != '\\') result[pnpo++]='\\';
      result[pnpo]=0;
      strcat(result,filename);
      if((test=fopen(result,"rb")) != NULL) {
        fclose(test);
        return(1);
      } 
    }
  }
  strcpy(result,"c:\\gibsnich");
  return(0);
}
#endif



/* bitmap subroutines. 
   they are hand-made, so that anybody owning some good
   book about that stuff may insert something realy fancy here. */

void alloc_bitmap(bitmap* bmp) {
  unsigned int	size;
  bmp->bmu_wide = ROUNDUP(bmp->w * bmp->type, BITS_PER_BMUNIT);
  size = bmp->bmu_wide*BYTES_PER_BMUNIT * bmp->h;
  bmp->bits = findmem(size != 0 ? size : 1);
  memset(bmp->bits,0,size);
}

void clear_bitmap(bitmap* bmp) {
  memset((char*) bmp->bits,0,bmp->bmu_wide*BYTES_PER_BMUNIT * bmp->h);
}


void clear_bigbitmap(void) {
  register short size,i;
  BMUNIT** bits = pxlmem.bits; 
  size = MAX(pxlmem.bmu_wide*BYTES_PER_BMUNIT,1);
  for(i=0;i<pxlmem.h;i++) memset(bits[i],0,size);
}

void print_bitmap(bitmap *bmp) {
	BMUNIT *pt = (BMUNIT *) bmp->bits;
	int x, y, i;

	if (pt == NULL) return;
	fprintf(prot,"(printbitmap: \n");
	for (y = 0; y < bmp->h; ++y) {
            fprintf(prot,"[",y);
	    for (x = bmp->bmu_wide; x > 0; x--) {
		for (i = BITS_PER_BMUNIT - bmp->type; i >= 0;i-=bmp->type)
		    fprintf(prot,"%c",' '+((*pt >> i) & ((1<<bmp->type)-1)));
		++pt;
	    }
	    fprintf(prot,"]\n");
	}
        fprintf(prot,"sizes: type = %d, w = %d, h = %d, bmu wide = %d)\n",
	    bmp->type,bmp->w, bmp->h, bmp->bmu_wide);

}

void print_bigbitmap() {
	BMUNIT *pt;
	int x, y, i;
#define MAXC 50
#define MAXR 100
#define HOFF 650
#define VOFF 650
	if (pt == NULL) return;
	fprintf(prot,"(printbigbitmap: \n");
	for (y = VOFF; y < MIN(pxlmem.h,MAXR+VOFF); ++y) {
            fprintf(prot,"[%d",y);
            pt=pxlmem.bits[y]+HOFF/BITS_PER_BMUNIT;
	    for (x = MIN(pxlmem.w-HOFF,MAXC) / BITS_PER_BMUNIT;x>0;x--) {
		for (i = BITS_PER_BMUNIT - pxlmem.type; i >= 0;i-=pxlmem.type)
		    fprintf(prot,"%c",' '+((*pt >> i) & ((1<<pxlmem.type)-1)));
               ++pt;
	    }
	    fprintf(prot,"]\n");
	}
        fprintf(prot,"sizes: type = %d,w = %d, h = %d, bmu wide = %d)\n",
	    pxlmem.type,pxlmem.w, pxlmem.h, pxlmem.bmu_wide);
}

/*************************************************************************/
#if 0                   /* not needed anymore */
/************************************************************************/

/* warning: no clipping is done here ! */


void draw_rect_bnw(bitmap *bmp,short x, short y, short xr, short yr) {
  BMUNIT *pt= bmp->bits;
  BMUNIT lastjmask,firstjmask;
  short i,j,w,h;
  long firstjbmu,lastjbmu,firstibmu,lastibmu;
  
  w=xr-x+1;
  h=yr-y+1;
  
  /*fprintf(prot,"(draw_rect: x %d y %d w %d h % d ",x,y,w,h);*/

  firstjbmu= x >> BITS_LOG2;
  lastjbmu= (x-1+w) >> BITS_LOG2;
  firstibmu=y*bmp->bmu_wide;
  lastibmu=(y+h-1)*bmp->bmu_wide;
 
  firstjmask= bit_masks[BITS_PER_BMUNIT- (x & (BITS_PER_BMUNIT -1))];
  lastjmask= ~ bit_masks[BITS_PER_BMUNIT- ((x+w) & (BITS_PER_BMUNIT -1 ))];
  if(lastjmask==0) lastjmask=bit_masks[BITS_PER_BMUNIT];
  if(firstjbmu==lastjbmu) {
    firstjmask &= lastjmask;
    lastjmask = firstjmask;
  }
  pt[firstjbmu+firstibmu] |= firstjmask;
  pt[firstjbmu+lastibmu]  |= firstjmask;
  pt[lastjbmu+firstibmu]  |= lastjmask;
  pt[lastjbmu+lastibmu]   |= lastjmask;
 
  for(j=firstjbmu+1;j < lastjbmu; j++) {
    pt[j+firstibmu] |= bit_masks[BITS_PER_BMUNIT];
    pt[j+lastibmu]  |= bit_masks[BITS_PER_BMUNIT];
  }
  firstjmask= 1 << (BITS_PER_BMUNIT - 1 - (x & (BITS_PER_BMUNIT -1)));
  lastjmask= 1 << (BITS_PER_BMUNIT - 1 - ((x+w-1) & (BITS_PER_BMUNIT -1)));
 
  for(i=firstibmu+bmp->bmu_wide;i<lastibmu;i+=bmp->bmu_wide) {
    pt[i+firstjbmu] |= firstjmask;
    pt[i+lastjbmu]  |= lastjmask;
  }
  /*fprintf(prot,")");*/
}



void fill_rect_bnw(bitmap *bmp,short x, short y, short xr, short yr) {
  BMUNIT *pt= bmp->bits;
  BMUNIT lastjmask,firstjmask;
  short i,j,w,h;
  long firstjbmu,lastjbmu,firstibmu,lastibmu;
  
  /*fprintf(prot,"(fill_rect: x %d y %d w %d h % d ",x,y,w,h);*/

  x=MAX(x,0);
  y=MAX(y,0);
  xr=MIN(xr,bmp->h);
  yr=MIN(yr,bmp->h);
  w=xr-x+1;
  h=yr-y+1;
  firstjbmu= x >> BITS_LOG2;
  lastjbmu= xr >> BITS_LOG2;
  firstibmu=MAX(y*bmp->bmu_wide,0);
  lastibmu=MIN(yr*bmp->bmu_wide,bmp->h);
 
  firstjmask= bit_masks[BITS_PER_BMUNIT- (x & (BITS_PER_BMUNIT -1))];
  lastjmask= ~ bit_masks[BITS_PER_BMUNIT- ((xr+1) & (BITS_PER_BMUNIT -1 ))];
  if(lastjmask==0) lastjmask=bit_masks[BITS_PER_BMUNIT];
  if(firstjbmu==lastjbmu) {
    firstjmask &= lastjmask;
    lastjmask = firstjmask;
  }
  for(i=firstibmu;i<=lastibmu;i+=bmp->bmu_wide){
    pt[firstjbmu+i] |= firstjmask;
    pt[lastjbmu+i]  |= lastjmask;
    for(j=firstjbmu+1;j < lastjbmu; j++) pt[j+i] |= bit_masks[BITS_PER_BMUNIT];
  }
  /*fprintf(prot,")");*/
}

/*************************************************************************/
#endif                  /* end of: not needed anymore */
/************************************************************************/


void fill_rect_big_bnw(short x, short y, short xr, short yr) {
  BMUNIT *pt;
  BMUNIT lastjmask,firstjmask;
  short i,j;
  long firstjbmu,lastjbmu,firsti,lasti;
  register BMUNIT** bits = pxlmem.bits; 

  x=MAX(x,0);
  y=MAX(y,0);
  xr=MIN(xr,pxlmem.w-1);
  yr=MIN(yr,pxlmem.h-1);
  if((xr<x) || (yr < y)) return;
  firstjbmu= x >> BITS_LOG2;
  lastjbmu= xr >> BITS_LOG2;
  firsti=y;
  lasti=yr;
 
  /*fprintf(prot,"(fill_rect: x %d y %d w %d h % d ",x,y,w,h);*/

  firstjmask= bit_masks[BITS_PER_BMUNIT- (x & (BITS_PER_BMUNIT -1))];
  lastjmask= ~ bit_masks[BITS_PER_BMUNIT- ((xr+1) & (BITS_PER_BMUNIT -1 ))];
  if(lastjmask==0) lastjmask=bit_masks[BITS_PER_BMUNIT];
  if(firstjbmu==lastjbmu) {
    firstjmask &= lastjmask;
    lastjmask = firstjmask;
  }
  
  /*fprintf(prot,"fi %d li %d fj %d lj %d ",firsti,lasti,firstjbmu,lastjbmu);*/
  
  for(i=firsti;i<=lasti;i++){
    pt=bits[i];
    pt[firstjbmu] |= firstjmask;
    pt[lastjbmu]  |= lastjmask;
    for(j=firstjbmu+1;j < lastjbmu; j++) pt[j] |= bit_masks[BITS_PER_BMUNIT];
  }
  /*fprintf(prot,")");*/
}


void fill_rect_big_gs(uchar gl,short x, short y, short xr, short yr) {
  BMUNIT *pt;
  BMUNIT lastjmask,firstjmask, setall;
  short i,j;
  long firstjbmu,lastjbmu,firsti,lasti;
  register BMUNIT** bits = pxlmem.bits; 


  x=MAX(x,0);
  y=MAX(y,0);
  xr=MIN(xr,pxlmem.w-1);
  yr=MIN(yr,pxlmem.h-1);
  if((xr<x) || (yr < y)) return;
  firstjbmu= x >> (BITS_LOG2-GREYSCALE_LOG2);
  lastjbmu= xr >> (BITS_LOG2-GREYSCALE_LOG2);
  firsti=y;
  lasti=yr;
 
  /*fprintf(prot,"(fill_rect: x %d y %d xr %d yr % d ",x,y,xr,yr); */

  setall=0;
  for(i=0;i< BITS_PER_BMUNIT/GREYSCALE;i++)
    setall=(setall << GREYSCALE) | (BMUNIT) gl;

  firstjmask= bit_masks[BITS_PER_BMUNIT- GREYSCALE*(x & (BITS_PER_BMUNIT/GREYSCALE -1))];
  lastjmask= ~bit_masks[BITS_PER_BMUNIT- GREYSCALE*((xr & (BITS_PER_BMUNIT/GREYSCALE -1))+1)];
  if(lastjmask==0) lastjmask=bit_masks[BITS_PER_BMUNIT];
  if(firstjbmu==lastjbmu) {
    firstjmask &= lastjmask;
    lastjmask = firstjmask;
  }
  /*fprintf(prot,"fm %x lm %x ",firstjmask,lastjmask);*/
  firstjmask &= setall;
  lastjmask &= setall;
  
  
  /*fprintf(prot,"fi %d li %d fj %d lj %d ",firsti,lasti,firstjbmu,lastjbmu);*/
  
  for(i=firsti;i<=lasti;i++){
    pt=bits[i];
    pt[firstjbmu] |= firstjmask;
    pt[lastjbmu]  |= lastjmask;
    for(j=firstjbmu+1;j < lastjbmu; j++) pt[j] |= setall;
  }
  /*fprintf(prot,")");*/
}



void copy_bigbitmap_bitmap(bitmap *src,short x,short y) {
  uchar rs; uchar ls;
  BMUNIT lsave, last, lastjmask;
  BMUNIT *ssp, *dp;
  register BMUNIT *sp;
  register short j;
  short dind,dend;
  short firstjbmu,lastjbmu;
  register BMUNIT** bits = pxlmem.bits; 

  /* test it without pk.s 
  if(pxlmem.type== BLACKNWHITE) 
    fill_rect_big_bnw(x,y,src->w+x,src->h+y);
  else
    fill_rect_big_gs(0xff,x,y,src->w+x,src->h+y);
  return;
  */
  
  if(src->type != pxlmem.type) {
    fprintf(prot,
      "\n(fatal error: copy_bigbitmap_bitmap: this cant happen here)");
     exit(1);
  }

  
  if(src->type == BLACKNWHITE){

  lastjmask= ~ bit_masks[BITS_PER_BMUNIT- ((pxlmem.w) & (BITS_PER_BMUNIT -1 ))];
  if(lastjmask==0) lastjmask=bit_masks[BITS_PER_BMUNIT];
  
  if(y >= 0) {
    dind= y;
    dend= MIN(src->h+y-1,pxlmem.h-1);
    sp=src->bits;
  } else {
    dind= 0;
    dend= MIN(src->h+y-1,pxlmem.h-1);
    sp=src->bits- y*src->bmu_wide;
  }
  
  if(x>=0) firstjbmu= x >> BITS_LOG2; 
  else firstjbmu= -(BITS_PER_BMUNIT-1-x >> BITS_LOG2);
  lastjbmu= firstjbmu + src->bmu_wide - 1;
  lastjbmu= MIN(lastjbmu,pxlmem.bmu_wide-1);
 
   
  rs=x & (BITS_PER_BMUNIT-1);
  if(rs) {
    ls=BITS_PER_BMUNIT-rs;
    lsave=bit_masks[BITS_PER_BMUNIT];
  } else {
    ls=0;
    lsave=0;
  } 
  
  /*fprintf(prot,"\nx %d y%d ",x,y);  
  fprintf(prot,"w %d bw %d ",src->w,src->bmu_wide);
  fprintf(prot," di %d de %d ",dind,dend);
  fprintf(prot,"ljm %x ",lastjmask);
  fprintf(prot,"fjb %d ljb %d ",firstjbmu,lastjbmu);
  fprintf(prot,"rs %d ls %d \n",rs,ls);*/
   
  for(;dind<=dend;dind++){
    dp=bits[dind];
    ssp=sp;
    last=0;
    j=firstjbmu;

    if(j<0) {
      if(lastjbmu < -1) return;
      sp-= j;
      last= ((*(sp-1)) << ls) & lsave;
      j=0;
    }

    while(j<=lastjbmu){
      /* fprintf(prot,"di %d j %d \n",dind,j); */
      dp[j++] |= ((*sp) >> rs) | last;
      last= ((*sp) << ls) & lsave;
      sp++;
    }
    
    if(j<=pxlmem.bmu_wide-1) dp[j++] |= last; 
    if(j-1 == pxlmem.bmu_wide) dp[j-1]&= lastjmask;
 
    sp=ssp+src->bmu_wide;
  }


  } else {            /* this is two in one: now the GREYSCALE ... */
                      /* why am i afraid of pointers to functions ?*/

#ifndef GREYINBMU


  lastjmask= ~ bit_masks[BITS_PER_BMUNIT- 
                          ((pxlmem.w*GREYSCALE) & (BITS_PER_BMUNIT -1 ))];
  if(lastjmask==0) lastjmask=bit_masks[BITS_PER_BMUNIT];
  
  if(y >= 0) {
    dind= y;
    dend= MIN(src->h+y-1,pxlmem.h-1);
    sp=src->bits;
  } else {
    dind= 0;
    dend= MIN(src->h+y-1,pxlmem.h-1);
    sp=src->bits- y*src->bmu_wide;
  }
  
  if(x>=0) firstjbmu= (x*GREYSCALE) >> BITS_LOG2;
  else firstjbmu= -((BITS_PER_BMUNIT-1-x*GREYSCALE) >> BITS_LOG2);
  lastjbmu= firstjbmu + src->bmu_wide - 1;
  lastjbmu= MIN(lastjbmu,pxlmem.bmu_wide-1);
 
   
  rs=(x & (BITS_PER_BMUNIT / GREYSCALE -1)) * GREYSCALE;
  if(rs) {
    ls=BITS_PER_BMUNIT-rs;
    lsave=bit_masks[BITS_PER_BMUNIT];
  } else {
    ls=0;
    lsave=0;
  } 

  /*fprintf(prot,"\n w %d bw %d ",src->w,src->bmu_wide);
  fprintf(prot," di %d de %d ",dind,dend);
  fprintf(prot,"ljm %x ",lastjmask);
  fprintf(prot,"fjb %d ljb %d ",firstjbmu,lastjbmu);
  fprintf(prot,"rs %d ls %d \n",rs,ls); */ 
   
  for(;dind<=dend;dind++){
    dp=bits[dind];
    ssp=sp;
    last=0;
    j=firstjbmu;
    
    if(j<0) {
      if(lastjbmu < -1) return;
      sp-= j;
      last= ((*(sp-1)) << ls) & lsave;
      j=0;
    }

    while(j<=lastjbmu){
      /* fprintf(prot,"di %d j %d \n",dind,j); */
      dp[j++] |= ((*sp) >> rs) | last;
      last= ((*sp) << ls) & lsave;
      sp++;
    }

    if(j<=pxlmem.bmu_wide-1) dp[j++] |= last; 
    if(j-1 == pxlmem.bmu_wide) dp[j-1]&= lastjmask;
    sp=ssp+src->bmu_wide;
  }

#else     /* this is three in one: now BITS_PER_BMUNIT==GREYSCALE */

  
  if(y >= 0) {
    dind= y;
    dend= MIN(src->h+y-1,pxlmem.h-1);
    sp=src->bits;
  } else {
    dind= 0;
    dend= MIN(src->h+y-1,pxlmem.h-1);
    sp=src->bits- y*src->bmu_wide;
  }
  
  if(x>=0) {
    firstjbmu= x;
    lastjbmu= firstjbmu + src->bmu_wide - 1;
    lastjbmu= MIN(lastjbmu,pxlmem.bmu_wide-1);
  } else {
    sp-=x; 
    firstjbmu= 0;
    lastjbmu= firstjbmu + src->bmu_wide - 1+x;
    lastjbmu= MIN(lastjbmu,pxlmem.bmu_wide-1);
  }
     
  /*fprintf(prot,"\n w %d bw %d ",src->w,src->bmu_wide);
  fprintf(prot," di %d de %d ",dind,dend);
  fprintf(prot,"fjb %d ljb %d ",firstjbmu,lastjbmu); */
   
  for(;dind<=dend;dind++){
    dp=bits[dind];
    ssp=sp;
    for(j=firstjbmu;j<=lastjbmu;) {
      /* fprintf(prot,"di %d j %d \n",dind,j); */
      dp[j++] |= (*sp);
      sp++;
    }
    sp=ssp+src->bmu_wide;
  }
#endif

  } /* end of three in one */

 
  /*fprintf(prot,")");*/ 
} 










